//app方法：
//参数为：1，调用app原生方法名。2，回调函数名。3，传参数组。
//传参数组的数组元素为只有一个属性名值对的对象。
dxlHttp.bbs = windowHttp + '//bbs.daoxila.' + s4Com + "/";
;(function ($) {
	
	//发送请求封装
	function sendRequest(def, method, callback, context, post){
		if (!context) {
			context = window;
		}
		if(method == 'get'){
			/*$.get(dxlHttp.bbs + $.bbsApi + $.param(def), function(data){
				callback && callback.call(context, data);
			});*/
			$.ajax({
				type: "GET",
				url: dxlHttp.bbs + $.bbsApi + $.param(def),
				xhrFields: {
					withCredentials: true
				},
				success: function(data){
					callback && callback.call(context, data);
				}
			})
		}else{
			/*$.post(dxlHttp.bbs + $.bbsApi + $.param(def), post, function(data){
				callback && callback.call(context, data);
			});*/
			$.ajax({
				type: "POST",
				url: dxlHttp.bbs + $.bbsApi + $.param(def),
				xhrFields: {
					withCredentials: true
				},
				data: post,
				success: function(data){
					callback && callback.call(context, data);
				}
			})
		}
		
	}
	
	
	$.extend({
		bbsApi: 'api/mobile/index.php?'
	});
	if (navigator.userAgent.indexOf("dxlapp-android") != "-1"){
		$.extend({
			'platform': "appAndroid",
			'dxlBbsCallBack': function (action, cb, par) {
				if (!cb){
					cb = 'null';
				};
				if(!par){
					par = {};
				}
				window.android.forumCallBack(action, cb, JSON.stringify(par));

			}
		});
	}else if(navigator.userAgent.indexOf("dxlapp-iphone") != "-1"){
		$.extend({
			'platform': "appIos",
			'dxlBbsCallBack': function (action, cb, par) {

				var option = {};
				option.title = action;
				if (cb){
					option.callback = cb;
				};
				if(par){
					for(var key in par){
						option[key] = par[key];
					};
				}
				
				var uri = 'gap://XXX#' + JSON.stringify(option);
				window.location = uri;
			}
		});
	} else {
		$.extend({
			'platform': "normal",
			/*'format': function(fm ,time){							//日期格式化函数，未完成
				if (typeof time === 'string' || typeof time === 'number'){
					time = new Date(time);
				};
			},*/
			'downloadDiv': function(){
				if(sessionStorage.hideD == '1' || $.isUrlPar('utm_campaign') == 'Wapunbar' || $.cookie("utm_campaign") == 'Wapunbar'){
					return;
				}
				var html = '<section id="appDownBot">' +
								'<div class="appDownDiv">' +
									'<span class="close"></span>' +
									'<span class="topBg"></span>' +
									'<div class="words clearfix">' +
										'<span class="le"></span>' +
										'<span class="mid">到喜啦APP<br>与您分享结婚中的故事</span>' +
										'<span class="ri">立即下载</span>' +
									'</div>' +
								'</div>' +
							'</section>';
				$('body').append(html);
				//添加app下载banner条
				$('#appDownBot .close').touchClick(function(e){
					e.stopPropagation();
					e.preventDefault();
					$('#appDownBot').hide();
                    // sessionStorage
                    sessionStorage.hideD = '1';
				});
				$.dxlInclud(['wapToApp'], function() {
					$('#appDownBot .words .ri').touchClick(function(e){
						if($.isUrlPar("tid")){
								$.wapToApp('bbs/detail?tid=' + $.isUrlPar("tid"));
						}else{
							window.location.href = dxlHttp.m + "app?utm_source=App&utm_content=ziyou&utm_term=BBS";
						}
					});
				});
			},
			
			'syncLogin': function(cb) {										//同步登录状态
				if($.cookie('bbs_sylogin') || $.cookie('bbs_rename')){
					var shouldEnd = 0;
					var finished = 0;
					if ($.cookie('bbs_sylogin')) shouldEnd++;
					if ($.cookie('bbs_rename')) shouldEnd++;
					function endRequest() {
						finished++;
						if(finished == shouldEnd){
							$.cookie('bbs_sylogin', '', {path:'/','domain':'daoxila.com'});
							$.cookie('bbs_rename', '', {path:'/','domain':'daoxila.com'});
							cb && cb.done && cb.done();
							cb && cb.always && cb.always();
						}
					}
					$.ajax({url:$.cookie('bbs_sylogin'), type:'GET', dataType:'JSONP', success:endRequest, error:endRequest});
					$.ajax({url:$.cookie('bbs_rename'), type:'GET', dataType:'JSONP', success:endRequest, error:endRequest});
				} else {
					cb && cb.fail && cb.fail();
					cb && cb.always && cb.always();
					return 'noLogin';
				}

			},
			
			'checkLogin': function(callback){							//判断是否登录，未登录时弹出登录弹层
				if ($.cookie('bbs_uid') == '0' || !$.cookie('bbs_uid')){
					$.syncLogin({										//如果主站已登录，bbs未登录，自动同步登陆
						done: function(){window.location.reload(true)},
						fail: function(){
							$.dxlInclud(['dxlMLogin'], function(data){
								$.mLogin({}, {
									loginOk: function () {
										$.syncLogin({					//完成主站登录后同步bbs登录
											done: function(){window.location.reload(true)},
											fail: function(){
												$.getJSON('http://my.daoxila.com/user/logout?callback=?');
												$.mAlert('登录失败,稍后重试');
											}
										});
									},
									registerOk: function () {
										$.syncLogin({
											done: function(){window.location.reload(true)},
											fail: function(){
												$.getJSON('http://my.daoxila.com/user/logout?callback=?');
												$.mAlert('登录失败,稍后重试');
											}
										});
									}
								});
							})
						}
					})
				} else {
					callback && callback();
				}
			},
			'saveCookie': function(data){							//保存常用cookie
				data.Variables.hash && $.cookie('hash', data.Variables.hash, {path:'/', domain:'bbs.daoxila.com'});
				data.Variables.formhash && $.cookie('formhash', data.Variables.formhash, {path:'/', domain:'bbs.daoxila.com'});
				data.Variables.member_uid && $.cookie('bbs_uid', data.Variables.member_uid, {path:'/', domain:'bbs.daoxila.com'});
			},
			'viewthread': function (par, callback, context) {		//获取指定页面的数据
				var def = {
					module: "dxl_app_viewthread",
					version: 4,
					ppp: 15
				}
				def = $.extend(def, par);
				sendRequest(def, 'get', callback, context);
			},
			'forumdisplay': function (par, callback, context) {		//获取话题列表数据
				var def = {
					module: 'forumdisplay',
					version: 4,
					charset: 'utf-8',
					orderby: 'dblastpost',
					tpp: 15,
					page: 1,
				}
				def = $.extend(def, par);
				sendRequest(def, 'get', callback, context);
			},
			
			/*'forumupload': function (par, callback, context) {		//上传图片,未完成
				var def = {
					module: 'forumupload',
					version: 4,
					uid: $.cookie('bbs_uid'),
					hash: $.cookie('hash')
				}
				data = {
					hash: $.cookie('hash'),
					Filedata: par.Filedata
				}
				sendRequest(def, 'post', callback, context, data);
			},*/
			'forumupload': function (par, callback, context) {				//上传图片,base64版
				var def = {
					module: 'forumupload',
					version: 4
				};
				data = {};
				$.extend(data, par);
				$.post(dxlHttp.bbs + 'api/dxlapp/index.php?' + $.param(def), data)			//李良写的，非discuz原生接口
					.done(function(data){
						callback.call(context, null, data);
					}).fail(function(data){
						callback.call(context, data);
				});
			},
			
			
			'newthread': function (par, callback, context) {		//发贴接口
				var def = {
					module: 'newthread',
					version: 4,
					topicsubmit: 'yes',
					mapifrom: 'wx',
					charset: 'utf-8',
					siteid: 247742674,
					siteuid: 2788841,
					login: 'yes'
				}
				def.fid = par.fid;
				var data = {
					formhash: par.formhash || $.cookie('formhash'),
					allowphoto: 0,
					typeid: 629,
					allownoticeauthor: 1,
					subject: par.subject,
					message: par.message
					//mobiletype: 2,
				}
				if (par.attachnew && par.attachnew.length > 0){
					
					data.attachnew = {};
					par.attachnew.forEach(function(o, i){
						data.attachnew[o] = {description: ""};
					})
				}
				sendRequest(def, 'post', callback, context, data);
			},
			
			'sendreply': function (par, callback, context) {		//回复帖子接口
				var def = {
					module: 'sendreply',
					version: 4,
					replysubmit: 'yes'
				}
				def.fid = par.fid;
				def.tid = par.tid;
				
				var data = {
					formhash: par.formhash || $.cookie('formhash'),
					message: par.message,
				//	mobiletype: par.mobiletype						//设备类型（未定）
				}
				
				if (par.pid){						//如果是回帖
					data.reppid = par.pid;
					data.reppost = par.pid;
					data.hash = par.hash || $.cookie('hash');
					var date = new Date(par.dbdateline*1000);
					data.noticetrimstr = '[quote][color=#999999]' + par.username + ' 发表于' + date.getFullYear() + '-' + (date.getMonth() >= 9 ? (date.getMonth() + 1) : '0' + (date.getMonth() + 1)) + '-' + date.getDate() + '\r\n' + '[/color][color=#999999]' + par.msg + '[/color][/quote]';
				}
				
				sendRequest(def, 'post', callback, context, data);
			},
			
			
			'recommend': function (par, callback, context) {		//话题点赞接口
				var def = {
					module: 'recommend',
					action: 'recommend',
					do: 'add',
					version: 4,
					hash: $.cookie('formhash')
				}
				def = $.extend(def, par);
				sendRequest(def, 'get', callback, context);
			},
			'postreview': function (par, callback, context) {		//评论点赞接口
				var def = {
					module: 'recommend',
					action: 'postreview',
					do: 'support',
					version: 4,
					hash: $.cookie('formhash')
				}
				def = $.extend(def, par);
				sendRequest(def, 'get', callback, context);
			}
			
		});
	}
})(jQuery);


/*设定基准字号*/
$(function(){
	$(window).resize(function(){
		$('body').css({
			'font-size':$(window).width()*12/320
		});
	});
	$(window).resize();
});